﻿local n = select(2, ...)

-- window settings
n.windowsettings = {
	pos = { "BOTTOMRIGHT","UIParent","BOTTOMRIGHT", -18, 62},
	width = 150,
	maxlines = 8,
	backgroundalpha = 0,
	scrollbar = true,

	titleheight = 16,
	titlealpha = 0,
	titlefont = GameFontNormalSmall:GetFont(),
	titlefontsize = 11,
	titlefontcolor = {1, .82, 0},
	buttonhighlightcolor = {1, .82, 0},

	lineheight = 14,
	linegap = 1,
	linealpha = 1,
	linetexture = [[Interface\AddOns\Numeration\gradient]],
	linefont = GameFontNormalSmall:GetFont(),
	linefontsize = 11,
	linefontcolor = {1, 1, 1},
}

-- core settings
n.coresettings = {
	refreshinterval = 1,
	minfightlength = 15,
	combatseconds = 3,
	shortnumbers = true,
}

-- available types and their order
n.types = {
	{
		name = "Damage",
		id = "dd",
		c = {171/255, 243/255, 50/255},
	},
	{
		name = "Damage Targets",
		id = "dd",
		view = "Targets",
		onlyfights = true,
		c = {171/255, 243/255, 50/255},
	},
	{
		name = "Damage Taken: Targets",
		id = "dt",
		view = "Targets",
		onlyfights = true,
		c = {252/255, 163/255, 41/255},
	},
	{
		name = "Damage Taken: Abilities",
		id = "dt",
		view = "Spells",
		c = {252/255, 163/255, 41/255},
	},
	{
		name = "Friendly Fire",
		id = "ff",
		c = {1,1, 0},
	},
	{
		name = "Healing + Absorbs",
		id = "hd",
		id2 = "ga",
		c = {0, .85, .99},
	},
	{
		name = "Overhealing",
		id = "oh",
		c = {0, .85, .99},
	},
	{
		name = "Dispels",
		id = "dp",
		c = {1, .5, .7},
	},
	{
		name = "Interrupts",
		id = "ir",
		c = {.6, .15, .8},
	},
	{
		name = "Power Gains",
		id = "pg",
		c = {11/255, 113/255, 225/255},
	},
	{
		name = "Death Log",
		id = "deathlog",
		view = "Deathlog",
		onlyfights = true,
		c = {.5, .5, .5},
	},
}
