﻿
---------------------------------------------------------------
-------------------[[        Config        ]]------------------
---------------------------------------------------------------
local font = GameFontHighlight:GetFont()
local Ccolor = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
local media = "Interface\\AddOns\\aPanels\\media\\"

local xpbarsize = {
	['Width'] = 390,
	['Height'] = 20,
}

local xppos = {"BOTTOM", UIParent, "BOTTOM", 0, 60}

---------------------------------------------------------------
-------------------[[     Config    End    ]]------------------
---------------------------------------------------------------

local frameBD = {
    edgeFile = media.."grow", edgeSize = 3,
    bgFile = "Interface\\Buttons\\WHITE8x8",
    insets = {left = 3, right = 3, top = 3, bottom = 3}
}

local createpanel = function(frame, s, r, g, b, a, ba)
    frame:SetFrameStrata(s)
    frame:SetBackdrop(frameBD)
    frame:SetBackdropColor(r, g, b, a)
    frame:SetBackdropBorderColor(0, 0, 0, ba)
	return frame
end

local setsize = function(frame, anchor, m)
    frame:SetPoint("TOPLEFT", anchor, "TOPLEFT", -m, m)
    frame:SetPoint("BOTTOMRIGHT", anchor, "BOTTOMRIGHT", m, -m)
    return frame
end
--====================================================--
--[[                 -- shadow --                   ]]--
--====================================================--	
local PShadow = CreateFrame("Frame", nil, UIParent)
PShadow:SetFrameStrata("BACKGROUND")
PShadow:SetBackdrop({bgFile = media.."shadow"})
PShadow:SetBackdropColor(0, 0, 0, 0.3)
setsize(PShadow, UIParent, 0)

--====================================================--
--[[            -- XP bar --  Monolit  saulhudson   ]]--
--====================================================--
local _G = getfenv(0)

local xpbar = CreateFrame("Frame", "sExperienceBar", UIParent)
xpbar:SetPoint(unpack(xppos)) -- Adjusted here to move the bar
xpbar:SetWidth(xpbarsize.Width)
xpbar:SetHeight(xpbarsize.Height)
xpbar:SetBackdrop(frameBD)
xpbar:SetBackdropColor(0,0,0,0.3)
xpbar:SetBackdropBorderColor(0,0,0,1)

local indictator = xpbar:CreateTexture(nil, "OVERLAY")
indictator:SetWidth(2)
indictator:SetTexture(Ccolor.r, Ccolor.g, Ccolor.b)
indictator:SetHeight(xpbarsize.Height-6)

local textMain = xpbar:CreateFontString(nil, "OVERLAY")
textMain:SetPoint("LEFT", indictator, "RIGHT", 10, 0)
textMain:SetFontObject(GameFontHighlightSmall)

local textCT = xpbar:CreateFontString(nil, "OVERLAY")
textCT:SetPoint("CENTER", xpbar, "CENTER", 0, 2)
textCT:SetFontObject(GameFontHighlightSmall)

--[[Helper Functions]]--
function xpbar:Move(ind, perc)
	ind:ClearAllPoints()
	ind:SetPoint("TOPLEFT", xpbarsize.Width * perc, -3)
end

--[[Update Functions]]--
function xpbar:PLAYER_ENTERING_WORLD()
	if UnitLevel('player') == MAX_PLAYER_LEVEL then
        self:UPDATE_FACTION()
	else
		self:PLAYER_XP_UPDATE()
 	end
end

function xpbar:PLAYER_XP_UPDATE()

	local min = UnitXP("player")
	local max = UnitXPMax("player")
	local rested =  GetXPExhaustion()

	textMain:SetFormattedText("|cffffffff%.1f|r%%", min/max*100)
	textCT:SetFormattedText("")
	textCT:SetAlpha(0.001)

   	self:Move(indictator, min/max)

end
xpbar.PLAYER_LEVEL_UP = xpbar.PLAYER_XP_UPDATE

function xpbar:UPDATE_FACTION()

    if UnitLevel('player') == MAX_PLAYER_LEVEL then
		local name, standing, min, max, value = GetWatchedFactionInfo()

		if(not name) then return nil end
		max, min = (max-min), (value-min)

	   	textMain:SetFormattedText("|cffffffff%.1f|r%%", min/max*100)
		textCT:SetFormattedText("|cffffffff%s|r (|cffffffff%s|r)", name, _G['FACTION_STANDING_LABEL'..standing])
		textCT:SetAlpha(0.001)

	   	self:Move(indictator, min/max)
	end
end

xpbar:EnableMouse(true)
xpbar:SetScript("OnEnter", function() textCT:SetAlpha(1) end)
xpbar:SetScript("OnLeave", function() textCT:SetAlpha(0.001) end)

--[[RegisterEvents]]--
xpbar:SetScript("OnEvent", function(self, event, ...) self[event](self, event, ...)end)
xpbar:RegisterEvent("PLAYER_XP_UPDATE")
xpbar:RegisterEvent('UPDATE_FACTION')
xpbar:RegisterEvent("PLAYER_LEVEL_UP")
xpbar:RegisterEvent("PLAYER_ENTERING_WORLD")

--====================================================--
--[[              -- World Channel --               ]]--
--====================================================--
local Leftline = CreateFrame("Frame", nil, xpbar)
createpanel(Leftline, "BACKGROUND", Ccolor.r, Ccolor.g, Ccolor.b, 1, 1)
Leftline:SetSize(300,7.5)
Leftline:SetPoint("RIGHT", xpbar, "LEFT", 3, 0)

local Leftbutton = CreateFrame("Frame", nil, xpbar)
createpanel(Leftbutton, "BACKGROUND", 0, 0, 0, 0.3, 1)
Leftbutton:SetSize(25,14)
Leftbutton:SetPoint("RIGHT", xpbar, "LEFT", -293, 0)

Leftbutton:SetScript('OnMouseUp', function() WorldChannel() end)
Leftbutton:SetScript('OnEnter', function()
 		GameTooltip:SetOwner(Leftbutton)
		GameTooltip:AddLine("WorldChannel")
		GameTooltip:Show()
		Leftbutton:SetBackdropColor(Ccolor.r, Ccolor.g, Ccolor.b, 0.7)
		end)
Leftbutton:SetScript('OnLeave', function() Leftbutton:SetBackdropColor(0, 0, 0, 0.3) GameTooltip:Hide() end)

--====================================================--
--[[               -- Damage Meter --               ]]--
--====================================================--

local Rightline = CreateFrame("Frame", nil, xpbar)
createpanel(Rightline, "BACKGROUND", Ccolor.r, Ccolor.g, Ccolor.b, 1, 1)
Rightline:SetSize(300,7.5)
Rightline:SetPoint("LEFT", xpbar, "RIGHT", -3, 0)

local Rightbutton = CreateFrame("Frame", nil, xpbar)
createpanel(Rightbutton, "BACKGROUND", 0, 0, 0, 0.3, 1)
Rightbutton:SetSize(25,14)
Rightbutton:SetPoint("LEFT", xpbar, "RIGHT", 293, 0)

Rightbutton:SetScript('OnMouseUp', function() 
        if IsAddOnLoaded("Numeration") then
            Numeration:ToggleVisibility()
	    elseif IsAddOnLoaded("Skada") then
            Skada:ToggleWindow()
	    else print "Can't find Numeration or Skada!"
        end 
		end)
Rightbutton:SetScript('OnEnter', function()
 		GameTooltip:SetOwner(Rightbutton)
		GameTooltip:AddLine("Damage Meter")
		GameTooltip:Show()
		Rightbutton:SetBackdropColor(Ccolor.r, Ccolor.g, Ccolor.b, 0.7)
		end)
Rightbutton:SetScript('OnLeave', function() Rightbutton:SetBackdropColor(0, 0, 0, 0.3) GameTooltip:Hide() end)

--====================================================--
--[[                 -- Screen --                   ]]--
--====================================================

local TOPAFK = CreateFrame("Frame", nil, WorldFrame)
createpanel(TOPAFK, "FULLSCREEN_DIALOG", 0, 0, 0, 0.5, 0)
TOPAFK:SetPoint("TOPLEFT",WorldFrame,"TOPLEFT",-5,5)
TOPAFK:SetPoint("BOTTOMRIGHT",WorldFrame,"TOPRIGHT",5,-80)

local BOTTOMAFK = CreateFrame("Frame", nil, WorldFrame)
createpanel(BOTTOMAFK, "FULLSCREEN_DIALOG", 0, 0, 0, 0.5, 0)
BOTTOMAFK:SetPoint("BOTTOMLEFT",WorldFrame,"BOTTOMLEFT",-5,-5)
BOTTOMAFK:SetPoint("TOPRIGHT",WorldFrame,"BOTTOMRIGHT",5,75)

local BOTTOMTEXT = BOTTOMAFK:CreateFontString(nil, "OVERLAY")
BOTTOMTEXT:SetPoint("TOP", BOTTOMAFK, "TOP", 0, -10)
BOTTOMTEXT:SetFont(font, 20, "NONE")
BOTTOMTEXT:SetTextColor(0, 0, 0,.5)
BOTTOMTEXT:SetText("Click to hide.")

local Clock = TOPAFK:CreateFontString(nil, "OVERLAY")
Clock:SetPoint("BOTTOMLEFT", TOPAFK, "BOTTOMRIGHT", -280, 10)
Clock:SetFont(font, 27, "NONE")
Clock:SetTextColor(0.7, 0.7, 0.7)

local Date = TOPAFK:CreateFontString(nil, "OVERLAY")
Date:SetPoint("BOTTOMLEFT", TOPAFK, "BOTTOMRIGHT", -280, 34)
Date:SetFont(font, 17, "NONE")
Date:SetTextColor(0.7, 0.7, 0.7)

local AUI = TOPAFK:CreateFontString(nil, "OVERLAY")
AUI:SetPoint("BOTTOMRIGHT", TOPAFK, "BOTTOMRIGHT", -290, 13)
AUI:SetFont(font, 50, "NONE")
AUI:SetTextColor(0.7, 0.7, 0.7)
AUI:SetText("AltZ UI")

local Guide = CreateFrame("Frame", nil, WorldFrame)
createpanel(Guide, "FULLSCREEN_DIALOG", 0, 0, 0, 0.5, 0)
Guide:SetPoint("TOPLEFT",WorldFrame,"TOPLEFT",-5,-75)
Guide:SetPoint("BOTTOMRIGHT",WorldFrame,"BOTTOMRIGHT",5,70)
Guide:Hide()
local Guidetext = Guide:CreateFontString(nil, "OVERLAY")
Guidetext:SetPoint("CENTER",Guide,"CENTER",0,0)
Guidetext:SetFont(font, 15, "NONE")
Guidetext:SetTextColor(0.7, 0.7, 0.7)
Guidetext:SetText("|cff3399FF/rl|r - Reload UI \n \n |cff3399FF/hb|r - Key Binding Mode \n \n |cff3399FFSHIFT+Leftbutton|r - Set Focus \n \n |cff3399FFAlt+Leftbutton|r - Disenchant/Milling/Prospecting/Pick Lock \n \n |cff3399FFTab|r - Change between available channels. \n \n |cff3399FF/omf|r - Unlock UnitFrames \n \n |cff3399FFNumeration|r - Hold alt to move. \n \n Raid Control/World Flare button appears on topright of minimap when available. \n \n |cff3399FFEnjoy!|r")
Guidetext:Hide()
local Emailtext2 = Guide:CreateFontString(nil, "OVERLAY")
Emailtext2:SetPoint("CENTER",Guide,"CENTER",0,0)
Emailtext2:SetFont(font, 15, "NONE")
Emailtext2:SetTextColor(0.7, 0.7, 0.7)
Emailtext2:SetText("E-mail:359661355@qq.com \n \n If you have any errors or questions,please post it in the comments of wowinterface.com/bbs.ngacn.cc or send a e-mail to me. \n \n If you are posting errors please always support your comment with a screenshot and in case the lua error you are getting.")
Emailtext2:Hide()

local interval = 0
TOPAFK:SetScript('OnUpdate', function(self, elapsed)
 	interval = interval - elapsed
	if interval <= 0 then
        Clock:SetText(format("%s",date("%H:%M:%S")))
		Date:SetText(format("%s",date("%a %b/%d")))
		interval = .5
	end
end)

local Setup = CreateFrame("Frame", nil, BOTTOMAFK)
Setup:SetFrameStrata("TOOLTIP" )
Setup:SetPoint("TOPRIGHT",BOTTOMAFK,"TOPRIGHT",-285,-15)
Setup:SetSize(30,30)
Setup.texture = Setup:CreateTexture(nil)
Setup.texture:SetAllPoints(Setup)
Setup.texture:SetTexture(media.."setup")
Setup.texture:SetVertexColor(1, 1, 1)
Setup.texture:SetBlendMode("ADD")
local Setuptext = Setup:CreateFontString(nil, "OVERLAY")
Setuptext:SetPoint("RIGHT",Setup,"LEFT",-15,0)
Setuptext:SetFont(font, 30, "NONE")
Setuptext:SetTextColor(0.7, 0.7, 0.7)
Setuptext:SetText("Setup")
Setuptext:Hide()
Setup:SetScript('OnEnter', function() Setup.texture:SetVertexColor(.1, 1, .1) Setuptext:Show() end)
Setup:SetScript('OnLeave', function() Setup.texture:SetVertexColor(1, 1, 1) Setuptext:Hide() end)

local Info = CreateFrame("Frame", nil, BOTTOMAFK)
Info:SetFrameStrata("TOOLTIP" )
Info:SetPoint("TOPRIGHT",BOTTOMAFK,"TOPRIGHT",-245,-15)
Info:SetSize(29,29)
Info.texture = Info:CreateTexture(nil)
Info.texture:SetAllPoints(Info)
Info.texture:SetTexture(media.."info")
Info.texture:SetVertexColor(1, 1, 1)
Info.texture:SetBlendMode("ADD")
local Infotext = Info:CreateFontString(nil, "OVERLAY")
Infotext:SetPoint("RIGHT",Setup,"LEFT",-15,0)
Infotext:SetFont(font, 30, "NONE")
Infotext:SetTextColor(0.7, 0.7, 0.7)
Infotext:SetText("Info")
Infotext:Hide()
Info:SetScript('OnEnter', function() Info.texture:SetVertexColor(1, 1, .1) Infotext:Show() end)
Info:SetScript('OnLeave', function() Info.texture:SetVertexColor(1, 1, 1) Infotext:Hide() end)

local Email = CreateFrame("Frame", nil, BOTTOMAFK)
Email:SetFrameStrata("TOOLTIP" )
Email:SetPoint("TOPRIGHT",BOTTOMAFK,"TOPRIGHT",-200,-12)
Email:SetSize(35,35)
Email.texture = Email:CreateTexture(nil)
Email.texture:SetAllPoints(Email)
Email.texture:SetTexture(media.."email")
Email.texture:SetVertexColor(1, 1, 1)
Email.texture:SetBlendMode("ADD")
local Emailtext = Email:CreateFontString(nil, "OVERLAY")
Emailtext:SetPoint("RIGHT",Setup,"LEFT",-15,0)
Emailtext:SetFont(font, 30, "NONE")
Emailtext:SetTextColor(0.7, 0.7, 0.7)
Emailtext:SetText("Need Help?")
Emailtext:Hide()
Email:SetScript('OnEnter', function() Email.texture:SetVertexColor(.3, .8, 1) Emailtext:Show() end)
Email:SetScript('OnLeave', function() Email.texture:SetVertexColor(1, 1, 1) Emailtext:Hide() end)

TOPAFK:RegisterEvent("PLAYER_ENTERING_WORLD")
TOPAFK:RegisterEvent("PLAYER_FLAGS_CHANGED")

TOPAFK:SetScript("OnEvent",function(self,event,...) 
if(event == "PLAYER_ENTERING_WORLD") then 
    UIParent:Hide()
	UIFrameFadeIn(TOPAFK, 3, 0, 1)
	UIFrameFadeIn(BOTTOMAFK, 2, 0, 1)
	Setup:Show()
	Info:Show()
	Email:Show()
	BOTTOMAFK:EnableMouse(true)
	TOPAFK:UnregisterEvent("PLAYER_ENTERING_WORLD")
elseif UnitIsAFK("player") then
	local fadeInfo1 = {}
		fadeInfo1.mode = "OUT"
		fadeInfo1.timeToFade = 2
		fadeInfo1.finishedFunc = function() UIParent:Hide() end	--隐藏
		fadeInfo1.startAlpha = UIParent:GetAlpha()
		fadeInfo1.endAlpha = 0
		UIFrameFade(UIParent, fadeInfo1)
    UIFrameFadeIn(TOPAFK, 2, 0, 1)
	UIFrameFadeIn(BOTTOMAFK, 2, 0, 1)
	BOTTOMAFK:EnableMouse(true)
	Setup:Show()
	Info:Show()
	Email:Show()
end
end)

BOTTOMAFK:SetScript('OnMouseUp', function()
	UIFrameFadeIn(UIParent, 2, 0, 1)
    UIFrameFadeOut(TOPAFK, 2, 1, 0)
	UIFrameFadeOut(BOTTOMAFK, 2, 1, 0)
	BOTTOMAFK:EnableMouse(false)
	Setup:Hide()
	Info:Hide()
	Email:Hide()
end)

StaticPopupDialogs["Setup"] = {
	text = "Do you want to set to Deflaut Options and Reload UI? (Recommed when you use AltUI for the first time.)",
	button1 = "yes",
	button2 = "cancel",
	OnAccept = function() SetDBM() ReloadUI() end,
	OnCancel = function() 
	UIFrameFadeOut(TOPAFK, 2, 1, 0)
	UIFrameFadeOut(BOTTOMAFK, 2, 1, 0) 
	BOTTOMAFK:EnableMouse(false)
	end,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = true
}

Setup:SetScript('OnMouseUp', function()
UIFrameFadeIn(UIParent, 1, 0, 1)
StaticPopup_Show("Setup")
Guide:Hide() Guidetext:Hide() Emailtext2:Hide()
end)

Info:SetScript('OnMouseUp', function()
if Guidetext:IsShown()
then Guide:Hide() Guidetext:Hide()
else Guide:Show() Guidetext:Show() Emailtext2:Hide()
end
end)

Email:SetScript('OnMouseUp', function()
if Emailtext2:IsShown()
then Guide:Hide() Emailtext2:Hide()
else Guide:Show() Emailtext2:Show() Guidetext:Hide()
end
end)

Guide:SetScript('OnMouseUp', function()
Guide:Hide() Guidetext:Hide() Emailtext2:Hide()
end)

--====================================================--
--[[               -- statreport --                 ]]--
--====================================================--
if IsAddOnLoaded("StatReport") then 				  
local PStatReport = CreateFrame("Frame", nil, StatReport_Button)
createpanel(PStatReport, "BACKGROUND", 0, 0, 0, 0.2, 1)
setsize(PStatReport, "StatReport_Button", 3)
end
--====================================================--
--[[               -- Numeration --                 ]]--
--====================================================--
if IsAddOnLoaded("Numeration") then 
local Pnumeration = CreateFrame("Frame", nil, NumerationFrame)
createpanel(Pnumeration, "BACKGROUND", 0, 0, 0, 0.2, 1)
Pnumeration:SetPoint("TOPLEFT", "NumerationFrame", "TOPLEFT", 0, -8)
Pnumeration:SetPoint("BOTTOMRIGHT", "NumerationFrame", "BOTTOMRIGHT", 2, -1)
end

--====================================================--
--[[                 -- Skada --                    ]]--test
--====================================================--
if IsAddOnLoaded("Skada") then 
local function CreateBackdrop(f, t, tex)
	if f.backdrop then return end

	local b = CreateFrame("Frame", nil, f)
	b:SetPoint("TOPLEFT", -3, 3)
	b:SetPoint("BOTTOMRIGHT", 3, -3)
	createpanel(b,"BACKGROUND", 0, 0, 0, 0.3, 1)

	if f:GetFrameLevel() - 1 >= 0 then
		b:SetFrameLevel(f:GetFrameLevel() - 1)
	else
		b:SetFrameLevel(0)
	end

	f.backdrop = b
end

local Skada = Skada
local barmod = Skada.displays["bar"]

barmod.ApplySettings_ = barmod.ApplySettings
barmod.ApplySettings = function(self, win)
	barmod.ApplySettings_(self, win)
	
	local skada = win.bargroup

	skada:SetTexture("Interface\\Buttons\\WHITE8x8")
	skada:SetSpacing(1, 1)
	skada:SetFont(font, 10)
	skada:SetFrameLevel(5)
	
	skada:SetBackdrop(nil)
	if not skada.backdrop then
		CreateBackdrop(skada)
		skada.backdrop:ClearAllPoints()
		skada.backdrop:SetPoint('TOPLEFT', win.bargroup.button or win.bargroup, 'TOPLEFT', -3, 3)
		skada.backdrop:SetPoint('BOTTOMRIGHT', win.bargroup, 'BOTTOMRIGHT', 3, -3)
	end
end

for _, window in ipairs(Skada:GetWindows()) do
	window:UpdateDisplay()
end
end
--====================================================--
--[[         --  bar4&bar5 control panel --         ]]--
--====================================================--
local Pab45 = CreateFrame("Frame", nil, UIParent)
createpanel(Pab45, "BACKGROUND", 0, 0, 0, 0.3, 1)
Pab45:SetSize(14,360)
Pab45:SetPoint("RIGHT", UIparent, "RIGHT", -4, 0)
local Pab4text = Pab45:CreateFontString(nil, "OVERLAY")
Pab4text:SetPoint("RIGHT", Pab45, "BOTTOM", -80, 0)
Pab4text:SetFont(font, 14, "OUTLINE")
Pab4text:SetTextColor(Ccolor.r, Ccolor.g, Ccolor.b)
Pab4text:SetText("Click LeftButton to Hide/Show ActionBar 4")
local Pab5text = Pab45:CreateFontString(nil, "OVERLAY")
Pab5text:SetPoint("RIGHT", Pab45, "BOTTOM", -80, 25)
Pab5text:SetFont(font, 14, "OUTLINE")
Pab5text:SetTextColor(Ccolor.r, Ccolor.g, Ccolor.b)
Pab5text:SetText("Click RightButton to Hide/Show ActionBar 5")
Pab45:SetAlpha(0.1)
Pab4text:Hide()
Pab5text:Hide()
Pab45:RegisterEvent("PLAYER_ENTERING_WORLD") 
Pab45:SetScript("OnEvent",function(self,event,...) 
if(event == "PLAYER_ENTERING_WORLD") then 
rABS_MultiBarRight:Hide()
rABS_MultiBarLeft:Hide()
end
end)

Pab45:SetScript('OnMouseUp', function(self,b)
 if b == "LeftButton" then
	if (rABS_MultiBarRight:IsShown()) 
	then rABS_MultiBarRight:Hide()
	else rABS_MultiBarRight:Show() end
    else
	if (rABS_MultiBarLeft:IsShown()) 
	then rABS_MultiBarLeft:Hide()
	else rABS_MultiBarLeft:Show() end
	end
end)
Pab45:SetScript('OnEnter', function() Pab45:SetAlpha(1) Pab4text:Show() Pab5text:Show() end)
Pab45:SetScript('OnLeave', function() Pab45:SetAlpha(0.1) Pab4text:Hide() Pab5text:Hide() end)

SLASH_FRAME1 = "/frame"
SlashCmdList["FRAME"] = function(arg)
	if arg ~= "" then
		arg = _G[arg]
	else
		arg = GetMouseFocus()
	end
	if arg ~= nil and arg:GetName() ~= nil then
		local point, relativeTo, relativePoint, xOfs, yOfs = arg:GetPoint()
		ChatFrame1:AddMessage("|cffCC0000~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
		ChatFrame1:AddMessage("Name: |cffFFD100"..arg:GetName())
		if arg:GetParent() then
			ChatFrame1:AddMessage("Parent: |cffFFD100"..arg:GetParent():GetName())
		end
 
		ChatFrame1:AddMessage("Width: |cffFFD100"..format("%.2f",arg:GetWidth()))
		ChatFrame1:AddMessage("Height: |cffFFD100"..format("%.2f",arg:GetHeight()))
		ChatFrame1:AddMessage("Strata: |cffFFD100"..arg:GetFrameStrata())
		ChatFrame1:AddMessage("Level: |cffFFD100"..arg:GetFrameLevel())
 
		if xOfs then
			ChatFrame1:AddMessage("X: |cffFFD100"..format("%.2f",xOfs))
		end
		if yOfs then
			ChatFrame1:AddMessage("Y: |cffFFD100"..format("%.2f",yOfs))
		end
		if relativeTo then
			ChatFrame1:AddMessage("Point: |cffFFD100"..point.."|r anchored to "..relativeTo:GetName().."'s |cffFFD100"..relativePoint)
		end
		ChatFrame1:AddMessage("|cffCC0000~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
	elseif arg == nil then
		ChatFrame1:AddMessage("Invalid frame name")
	else
		ChatFrame1:AddMessage("Could not find frame info")
    end
end