local lib = LibStub("LibCooldown")
if not lib then error("ncCooldownFlash requires LibCooldown") return end

local filter = {
	["pet"] = "all",
	["item"] = {
		[6948] = true, -- hearthstone
	},
	["spell"] = {
	},
}

local flash = CreateFrame("Frame", nil, UIParent)
flash.icon = flash:CreateTexture(nil, "OVERLAY")
flash:SetScript("OnEvent", function()
	local mult = 4
	flash:SetPoint("CENTER", UIParent)
	flash:SetSize(50,50)
	flash:SetBackdrop({
	  bgFile = [[Interface\AddOns\ncCooldownFlash\solid]], 
	  edgeFile = [[Interface\AddOns\ncCooldownFlash\glow]], 
	  tile = false, tileSize = 0, edgeSize = mult, 
	  insets = { left = mult, right = mult, top = mult, bottom = mult}
	})
	flash:SetBackdropColor(.1,.1,.1)
	flash:SetBackdropBorderColor(.1,.1,.1)
	flash.icon:SetPoint("TOPLEFT", mult, -mult)
	flash.icon:SetPoint("BOTTOMRIGHT", -mult, mult)
	flash.icon:SetTexCoord(.08, .92, .08, .92)
	flash:Hide()
	flash:SetScript("OnUpdate", function(self, e)
		flash.e = flash.e + e
		if flash.e > .75 then
			flash:Hide()
		elseif flash.e < .25 then
			flash:SetAlpha(flash.e*4)
		elseif flash.e > .5 then
			flash:SetAlpha(1-(flash.e%.5)*4)
		end
	end)
	flash:UnregisterEvent("PLAYER_ENTERING_WORLD")
	flash:SetScript("OnEvent", nil)
end)
flash:RegisterEvent("PLAYER_ENTERING_WORLD")

lib:RegisterCallback("stop", function(id, class)
	if filter[class]=="all" or filter[class][id] then return end
	flash.icon:SetTexture(class=="item" and GetItemIcon(id) or select(3, GetSpellInfo(id)))
	flash.e = 0
	flash:Show()
end)