local _, ns = ...
local oUF = ns.oUF or oUF
assert(oUF, 'oUF Fader was unable to locate oUF install')

local function Update(self)
	local unit = self.unit

	local _, powerType = UnitPowerType(unit)
	local power = UnitPower(unit)

	if
		(self.FadeCasting and (UnitCastingInfo(unit) or UnitChannelInfo(unit))) or
		(self.FadeCombat and UnitAffectingCombat(unit)) or
		(self.FadeTarget and (unit:find('target') and UnitExists(unit))) or
		(self.FadeTarget and UnitExists('target')) or
		(self.FadeHealth and UnitHealth(unit) < UnitHealthMax(unit)) or
		(self.FadePower and ((powerType == 'RAGE' or powerType == 'RUNIC_POWER') and power > 0)) or
		(self.FadePower and ((powerType ~= 'RAGE' and powerType ~= 'RUNIC_POWER') and power < UnitPowerMax(unit))) or
		(self.FadeHover and GetMouseFocus() == self)
	then
			UIFrameFadeIn(self, 0.8, self:GetAlpha(), self.FadeMaxAlpha or 1)
			UIFrameFadeIn(rABS_MultiBarBottomLeft, 0.8, rABS_MultiBarBottomLeft:GetAlpha(), self.BarFaderMaxAlpha or 1)--
		    UIFrameFadeIn(rABS_MainMenuBar, 0.8, rABS_MainMenuBar:GetAlpha(), self.BarFaderMaxAlpha or 1)--
            UIFrameFadeIn(rABS_MultiBarBottomRight, 0.8, rABS_MultiBarBottomRight:GetAlpha(), self.BarFaderMaxAlpha or 1)--
		    UIFrameFadeIn(rABS_PetBar, 0.8, rABS_PetBar:GetAlpha(), self.BarFaderMaxAlpha or 1)--
		    UIFrameFadeIn(rABS_StanceBar, 0.8, rABS_StanceBar:GetAlpha(), self.BarFaderMaxAlpha or 1)--⻷
		    if select(2, UnitClass("player")) == "SHAMAN" then
		    UIFrameFadeIn(rABS_TotemBar, 0.8, rABS_TotemBar:GetAlpha(), self.BarFaderMaxAlpha or 1)--ͼ
		    end
	else
			UIFrameFadeOut(self, 1.5, self:GetAlpha(), self.FadeMinAlpha or 0)
		    UIFrameFadeOut(rABS_MultiBarBottomLeft, 1.5, rABS_MultiBarBottomLeft:GetAlpha(), self.BarFaderMinAlpha or 0)
			UIFrameFadeOut(rABS_MainMenuBar, 1.5, rABS_MainMenuBar:GetAlpha(), self.BarFaderMinAlpha or 0)
			UIFrameFadeOut(rABS_MultiBarBottomRight, 1.5, rABS_MultiBarBottomRight:GetAlpha(), self.BarFaderMinAlpha or 0)
		    UIFrameFadeOut(rABS_PetBar, 1.5, rABS_PetBar:GetAlpha(), self.BarFaderMinAlpha or 0)
		    UIFrameFadeOut(rABS_StanceBar, 1.5, rABS_StanceBar:GetAlpha(), self.BarFaderMinAlpha or 0)
		    if select(2, UnitClass("player")) == "SHAMAN" then
            UIFrameFadeOut(rABS_TotemBar, 1.5, rABS_TotemBar:GetAlpha(), self.BarFaderMinAlpha or 0) 
            end
	end
end

local function ForceUpdate(element)
	return Update(element.__owner)
end

local function Enable(self, unit)
	if
		unit == 'player' or
		unit == 'target' or
		unit == 'targettarget' or
		--unit == 'focus' or
		unit == 'pet'
	then
		if(self.FadeHover) then
			self:HookScript('OnEnter', Update)
			self:HookScript('OnLeave', Update)
		end
		if(self.FadeCombat) then
			self:RegisterEvent('PLAYER_REGEN_ENABLED', Update)
			self:RegisterEvent('PLAYER_REGEN_DISABLED', Update)
		end
		if(self.FadeTarget) then
			self:HookScript('OnShow', Update)
			self:RegisterEvent('UNIT_TARGET', Update)
			self:RegisterEvent('PLAYER_TARGET_CHANGED', Update)
		end
		if(self.FadeHealth) then
			self:RegisterEvent('UNIT_HEALTH', Update)
			self:RegisterEvent('UNIT_HEALTHMAX', Update)
		end
		if(self.FadePower) then
			self:RegisterEvent('UNIT_POWER', Update)
			self:RegisterEvent('UNIT_POWERMAX', Update)
		end

		if(self.FadeCasting) then
			self:RegisterEvent('UNIT_SPELLCAST_START', Update)
			self:RegisterEvent('UNIT_SPELLCAST_FAILED', Update)
			self:RegisterEvent('UNIT_SPELLCAST_STOP', Update)
			self:RegisterEvent('UNIT_SPELLCAST_INTERRUPTED', Update)
			self:RegisterEvent('UNIT_SPELLCAST_CHANNEL_START', Update)
			self:RegisterEvent('UNIT_SPELLCAST_CHANNEL_INTERRUPTED', Update)
			self:RegisterEvent('UNIT_SPELLCAST_CHANNEL_STOP', Update)
		end

		Update(self)

		return true
	end
end

local function Disable(self, unit)
	if
		unit == 'player' or
		unit == 'target' or
		unit == 'targettarget' or
		--unit == 'focus' or
		unit == 'pet'
	then
		if(self.FadeCombat) then
			self:UnregisterEvent('PLAYER_REGEN_ENABLED', Update)
			self:UnregisterEvent('PLAYER_REGEN_DISABLED', Update)
		end
		if(self.FadeTarget) then
			self:UnregisterEvent('UNIT_TARGET', Update)
			self:UnregisterEvent('PLAYER_TARGET_CHANGED', Update)
		end
		if(self.FadeHealth) then
			self:UnregisterEvent('UNIT_HEALTH', Update)
			self:UnregisterEvent('UNIT_HEALTHMAX', Update)
		end
		if(self.FadePower) then
			self:UnregisterEvent('UNIT_POWER', Update)
			self:UnregisterEvent('UNIT_POWERMAX', Update)
		end

		if(self.FadeCasting) then
			self:UnregisterEvent('UNIT_SPELLCAST_START', Update)
			self:UnregisterEvent('UNIT_SPELLCAST_FAILED', Update)
			self:UnregisterEvent('UNIT_SPELLCAST_STOP', Update)
			self:UnregisterEvent('UNIT_SPELLCAST_INTERRUPTED', Update)
			self:UnregisterEvent('UNIT_SPELLCAST_CHANNEL_START', Update)
			self:UnregisterEvent('UNIT_SPELLCAST_CHANNEL_INTERRUPTED', Update)
			self:UnregisterEvent('UNIT_SPELLCAST_CHANNEL_STOP', Update)
		end
	end
end

oUF:AddElement('Fader', Path, Enable, Disable)
