local enable = false
if not enable then return end

local _, ns = ...

local mediaPath = "Interface\\AddOns\\oUF_Mlight\\media\\"
local texture = "Interface\\Buttons\\WHITE8x8"
local glowTex = mediaPath.."glowTex"
local font, fontsize = mediaPath.."font.TTF", 10
local height, width = 15, 40
local scale = 1.0

local backdrop = {
    bgFile = texture,
    insets = {top = 0, left = 0, bottom = 0, right = 0},
}

local frameBD = {
    edgeFile = glowTex, edgeSize = 2,
    insets = {left = 2, right = 2, top = 2, bottom = 2}
}

local func = function(self, unit)
    self:SetScript("OnEnter", UnitFrame_OnEnter)
    self:SetScript("OnLeave", UnitFrame_OnLeave)

    self:RegisterForClicks"AnyUp"
	
    self.FrameBackdrop = CreateFrame("Frame", nil, self)
	self.FrameBackdrop:SetPoint("TOPLEFT", self, "TOPLEFT", -2, 2)
    self.FrameBackdrop:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", 2, -2)
    self.FrameBackdrop:SetBackdrop(frameBD)
    self.FrameBackdrop:SetBackdropBorderColor(0, 0, 0)

    local hp = CreateFrame("StatusBar", nil, self)
    hp:SetAllPoints(self)
	hp:SetBackdrop(backdrop)
	hp:SetBackdropColor(0, 0, 0, .3)
	
    hp.frequentUpdates = true
    hp.Smooth = true
	hp.colorClass = true
    hp.colorReaction = true
	
    hp:SetReverseFill(true)
	hp.PostUpdate = function(hp, unit, min, max)
    if UnitIsDeadOrGhost(unit) then hp:SetValue(0)
    else	
	hp:SetValue(max - hp:GetValue())
	end
	end
	
    self.Health = hp

    local info = hp:CreateFontString(nil, "OVERLAY")
    info:SetPoint("LEFT", hp)
    info:SetPoint("RIGHT", hp)
    info:SetFont(font, fontsize, "OUTLINE")
    info:SetShadowOffset(0, 0)
    info:SetTextColor(1, 1, 1)
    self:Tag(info, '[Mlight:raidinfo]')
	
	local raidname = hp:CreateFontString(nil, "OVERLAY")
    raidname:SetPoint("BOTTOMLEFT", hp,"BOTTOMRIGHT",2,1 )
    raidname:SetFont(font, fontsize, "OUTLINE")
    raidname:SetShadowOffset(0, 0)
    self:Tag(raidname, '[Mlight:color][Mlight:shortname]')

    local ricon = hp:CreateTexture(nil, "OVERLAY")
    ricon:SetPoint("BOTTOM", hp, "TOP", 0 , -5)
    ricon:SetSize(10 ,10)
    self.RaidIcon = ricon

    self.Range = {
        insideAlpha = 1,
        outsideAlpha = .3,
    }
end

oUF:RegisterStyle("Mlight_raid", func)
oUF:SetActiveStyle"Mlight_raid"

local raid = oUF:SpawnHeader('Raid_Mlight', nil, 'raid,party,solo',
'oUF-initialConfigFunction', ([[
self:SetWidth(%d)
self:SetHeight(%d)
self:SetScale(%d)
]]):format(width, height, scale),
'showPlayer', true,
'showSolo', true,
'showParty', true,
'showRaid', true,
'xoffset', 35,
'yOffset', -5,
'point', "LEFT",
'groupFilter', '1,2,3,4,5,6,7,8',
'groupingOrder', '1,2,3,4,5,6,7,8',
'groupBy', 'GROUP',
'maxColumns', 8,
'unitsPerColumn', 5,
'columnSpacing', 5,
'columnAnchorPoint', "TOP"
)
raid:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 200, -15)
