
  -- // rBuffFrameStyler
  -- // zork - 2010

  -----------------------------
  -- INIT
  -----------------------------
  
  --get the addon namespace
  local addon, ns = ...
  
  --generate a holder for the config data
  local cfg = CreateFrame("Frame")
  
  -----------------------------
  -- CONFIG
  -----------------------------
  
  cfg.buffframe = {
    scale           = 0.9,
    pos             = { a1 = "TOPRIGHT", af = "UIParent", a2 = "TOPRIGHT", x = -9, y = -22 }, 
    userplaced      = true, --want to place the bar somewhere else?
    locked          = true, --frame locked, can be unlocked ingame via /rbuff
    rowSpacing      = 7,
    colSpacing      = 2,
    buffsPerRow     = 15,
    gap             = 10, --gap in pixel between buff and debuff
  }

  cfg.tempenchant = {
    scale           = 0.9,
    pos             = { a1 = "TOPLEFT", af = "Minimap", a2 = "BOTTOMLEFT", x = 50, y = -9 }, 
    userplaced      = true, --want to place the bar somewhere else?
    locked          = true, --frame locked, can be unlocked ingame via /rbuff
    colSpacing      = 7,
  }  
  
  cfg.textures = {
    normal            = "Interface\\AddOns\\rBuffFrameStyler\\media\\gloss",
    outer_shadow      = "Interface\\AddOns\\rBuffFrameStyler\\media\\outer_shadow",
  }
  
  cfg.background = {
    showshadow        = false,   --show an outer shadow
    shadowcolor       = { r = 0, g = 0, b = 0, a = 0.2},
    inset             = 5,
  }
  
  cfg.color = {
    normal            = { r = 0.4, g = 0.35, b = 0.35, },
    classcolored      = false,
  }
  
  cfg.duration = {
    fontsize        = 12,
    pos             = { a1 = "BOTTOM", x = 2, y = -8 },
  }
  
  cfg.count = {
    fontsize        = 12,
    pos             = { a1 = "TOPRIGHT", x = 0, y = 0 },
  }
  
  cfg.font = GameFontHighlight:GetFont()

  -----------------------------
  -- HANDOVER
  -----------------------------
  
  --hand the config to the namespace for usage in other lua files (remember: those lua files must be called after the cfg.lua)
  ns.cfg = cfg
